; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

    MemCopyx PROTO :DWORD,:DWORD,:DWORD
    regcopy  PROTO :DWORD,:DWORD,:DWORD

    lcnt equ <10000000>
    cnt2 equ <5000000>
    cnt3 equ <2500000>
    cnt4 equ <1250000>
    cnt5 equ <625000>

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL hmem1 :DWORD
    LOCAL hmem2 :DWORD

    push esi
    push edi

    mov edi, 1


  ; short buffers
    mov hmem1, alloc(16384)
    mov hmem2, alloc(16384)

  ; long buffers
 ;     mov hmem1, alloc(1024*1024*8)
 ;     mov hmem2, alloc(1024*1024*8)

    invoke MemCopyx,hmem1,hmem2,32
    invoke regcopy,hmem1,hmem2,32

  REPEAT 4
    invoke GetTickCount
    push eax
    mov esi, lcnt
  @@:
    invoke MemCopyx,hmem1,hmem2,32
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 32 byte mem copy",13,10

    invoke GetTickCount
    push eax
    mov esi, lcnt
  @@:
    invoke regcopy,hmem1,hmem2,32
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 32 byte reg copy",13,10
  ENDM


  REPEAT 4
    invoke GetTickCount
    push eax
    mov esi, cnt2
  @@:
    invoke MemCopyx,hmem1,hmem2,128
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 128 byte mem copy",13,10

    invoke GetTickCount
    push eax
    mov esi, cnt2
  @@:
    invoke regcopy,hmem1,hmem2,128
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 128 byte reg copy",13,10
  ENDM


  REPEAT 4
    invoke GetTickCount
    push eax
    mov esi, cnt3
  @@:
    invoke MemCopyx,hmem1,hmem2,512
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 512 byte mem copy",13,10

    invoke GetTickCount
    push eax
    mov esi, cnt3
  @@:
    invoke regcopy,hmem1,hmem2,512
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 512 byte reg copy",13,10
  ENDM


  REPEAT 4
    invoke GetTickCount
    push eax
    mov esi, cnt4
  @@:
    invoke MemCopyx,hmem1,hmem2,2048
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2048 byte mem copy",13,10

    invoke GetTickCount
    push eax
    mov esi, cnt4
  @@:
    invoke regcopy,hmem1,hmem2,2048
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 2048 byte reg copy",13,10
  ENDM


  REPEAT 4
    invoke GetTickCount
    push eax
    mov esi, cnt5
  @@:
    invoke MemCopyx,hmem1,hmem2,8192
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 8192 byte mem copy",13,10

    invoke GetTickCount
    push eax
    mov esi, cnt5
  @@:
    invoke regcopy,hmem1,hmem2,8192
    sub esi, edi
    jnz @B
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," 8192 byte reg copy",13,10
  ENDM


    free hmem2
    free hmem1


    pop edi
    pop esi

    ret

main endp

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 4

MemCopyx proc src:DWORD,dst:DWORD,ln:DWORD

    push esi
    push edi

    cld
    mov esi, [esp+4+8]
    mov edi, [esp+8+8]
    mov ecx, [esp+12+8]

    shr ecx, 2
    rep movsd

    mov ecx, [esp+12+8]
    and ecx, 3
    rep movsb

    pop edi
    pop esi

    ret 12

MemCopyx endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

align 16

regcopy proc src:DWORD,dst:DWORD,ln:DWORD

    push ebx
    push esi
    push edi
    push ebp

    mov esi, [esp+4+16]     ; src
    mov edi, [esp+8+16]     ; dst
    mov ecx, [esp+12+16]    ; ln

    shr ecx, 4              ; div by 16
    jz tail

  @@:
    mov eax, [esi]
    mov ebx, [esi+4]
    mov edx, [esi+8]
    mov ebp, [esi+12]
    mov [edi], eax
    mov [edi+4], ebx
    mov [edi+8], edx
    mov [edi+12], ebp
    add esi, 16
    add edi, 16
    sub ecx, 1
    jns @B

  tail:
    mov ecx, [esp+12+16]    ; ln
    and ecx, 4
    jz quit

  @@:
    movzx eax, BYTE PTR [esi]
    mov [edi], al
    add esi, 1
    add edi, 1
    sub ecx, 1
    jnz @B

  quit:
    pop ebp
    pop edi
    pop esi
    pop ebx

    ret 12

regcopy endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

end start
